<?php
/* --------------------------------------------------------------
   dependent.inc.php 2018-06-07
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2018 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------
*/

/** @var \DatabaseModel $this */

// Remove configuration group from "ACTIVATE_SHIPPING_STATUS" configuration
$check = $this->query('SELECT * FROM `configuration` WHERE `configuration_key` = "ACTIVATE_SHIPPING_STATUS" AND `configuration_group_id` > 0',
                      true);
if($check->num_rows === 1)
{
	$query     = 'UPDATE `configuration` SET `configuration_group_id` = 0 WHERE `configuration_key` = "ACTIVATE_SHIPPING_STATUS"';
	$t_success &= $this->query($query);
}

// Add or update UPDATE_DOWNLOADER_CHECK_URL gm_configuration value
$check = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key` = "UPDATE_DOWNLOADER_CHECK_URL";');
if($check->num_rows === 0)
{
	$query = '
		INSERT INTO `gm_configuration`
		SET `gm_key`    = "UPDATE_DOWNLOADER_CHECK_URL",
			`gm_value`  = "https://updates.gambio-support.de/v2/check.php";
	';
	$this->query($query);
}


// Add or update UPDATE_DOWNLOADER_NOTIFY_URL gm_configuration value
$check = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key` = "UPDATE_DOWNLOADER_NOTIFY_URL";');
if($check->num_rows === 0)
{
	$query = '
		INSERT INTO `gm_configuration`
		SET `gm_key`    = "UPDATE_DOWNLOADER_NOTIFY_URL",
			`gm_value`  = "https://updates.gambio-support.de/v2/callingHome.php";
	';
	$this->query($query);
}

// DSGVO

// Add new version column to content_manager table
$check = $this->table_column_exists('content_manager', 'content_version');
if(!$check)
{
	$t_query   = "ALTER TABLE `content_manager` ADD `content_version` varchar(255) NOT NULL DEFAULT '' AFTER `languages_id`;";
	$t_success &= $this->query($t_query);
}

// Add new gm_conf "GM_SHOW_PRIVACY_WITHDRAWAL_WEB_FORM"
$check = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key` = "GM_SHOW_PRIVACY_WITHDRAWAL_WEB_FORM"', true);
if($check->num_rows === 0)
{
	$query     = 'INSERT INTO `gm_configuration` SET `gm_key` = "GM_SHOW_PRIVACY_WITHDRAWAL_WEB_FORM", `gm_value` = "1"';
	$t_success &= $this->query($query, true);
}

// Add new gm_conf "PRIVACY_CHECKBOX_WITHDRAWAL_WEB_FORM"
$check = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key` = "PRIVACY_CHECKBOX_WITHDRAWAL_WEB_FORM"', true);
if($check->num_rows === 0)
{
	$query     = 'INSERT INTO `gm_configuration` SET `gm_key` = "PRIVACY_CHECKBOX_WITHDRAWAL_WEB_FORM", `gm_value` = "0"';
	$t_success &= $this->query($query, true);
}

// Add new gm_conf "GM_SHOW_PRIVACY_GV_SEND"
$check = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key` = "GM_SHOW_PRIVACY_GV_SEND"', true);
if($check->num_rows === 0)
{
	$query     = 'INSERT INTO `gm_configuration` SET `gm_key` = "GM_SHOW_PRIVACY_GV_SEND", `gm_value` = "1"';
	$t_success &= $this->query($query, true);
}

// Add new gm_conf "PRIVACY_CHECKBOX_GV_SEND"
$check = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key` = "PRIVACY_CHECKBOX_GV_SEND"', true);
if($check->num_rows === 0)
{
	$query     = 'INSERT INTO `gm_configuration` SET `gm_key` = "PRIVACY_CHECKBOX_GV_SEND", `gm_value` = "0"';
	$t_success &= $this->query($query, true);
}

// Create agreements table if it doesn't exist
$t_check = $this->table_exists('agreements');
if(!$t_check)
{
	$query     = "
		CREATE TABLE `agreements` (
		  `agreements_id` int(11) NOT NULL AUTO_INCREMENT,
		  `customers_name` varchar(128) NOT NULL DEFAULT '',
		  `customers_email` varchar(128) NOT NULL DEFAULT '',
		  `language_id` int(11) NOT NULL ,
		  `ip_address` varchar(16) NOT NULL DEFAULT '',
		  `text` text NOT NULL,
		  `legal_text_version` varchar(11) NOT NULL DEFAULT '',
		  `content_group` int(11) NOT NULL ,
		  `date_added` datetime DEFAULT NULL,
		  `last_modified` timestamp NOT NULL ON UPDATE CURRENT_TIMESTAMP DEFAULT CURRENT_TIMESTAMP,
		  PRIMARY KEY (`agreements_id`)
		) ENGINE=InnoDB DEFAULT CHARSET=utf8 ;
	";
	$t_success &= $this->query($query, true);
}

// Add new gm_conf "LOG_IP_CALLBACK"
$check = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key` = "LOG_IP_CALLBACK"', true);
if($check->num_rows === 0)
{
	$query     = 'INSERT INTO `gm_configuration` SET `gm_key` = "LOG_IP_CALLBACK", `gm_value` = "0"';
	$t_success &= $this->query($query, true);
}

// Add new gm_conf "LOG_IP_CONTACT"
$check = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key` = "LOG_IP_CONTACT"', true);
if($check->num_rows === 0)
{
	$query     = 'INSERT INTO `gm_configuration` SET `gm_key` = "LOG_IP_CONTACT", `gm_value` = "0"';
	$t_success &= $this->query($query, true);
}

// Add new gm_conf "LOG_IP_TELL_A_FRIEND"
$check = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key` = "LOG_IP_TELL_A_FRIEND"', true);
if($check->num_rows === 0)
{
	$query     = 'INSERT INTO `gm_configuration` SET `gm_key` = "LOG_IP_TELL_A_FRIEND", `gm_value` = "0"';
	$t_success &= $this->query($query, true);
}

// Add new gm_conf "LOG_IP_FOUND_CHEAPER"
$check = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key` = "LOG_IP_FOUND_CHEAPER"', true);
if($check->num_rows === 0)
{
	$query     = 'INSERT INTO `gm_configuration` SET `gm_key` = "LOG_IP_FOUND_CHEAPER", `gm_value` = "0"';
	$t_success &= $this->query($query, true);
}

// Add new gm_conf "LOG_IP_REVIEWS"
$check = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key` = "LOG_IP_REVIEWS"', true);
if($check->num_rows === 0)
{
	$query     = 'INSERT INTO `gm_configuration` SET `gm_key` = "LOG_IP_REVIEWS", `gm_value` = "0"';
	$t_success &= $this->query($query, true);
}

// Add new gm_conf "LOG_IP_ACCOUNT_CONTACT"
$check = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key` = "LOG_IP_ACCOUNT_CONTACT"', true);
if($check->num_rows === 0)
{
	$query     = 'INSERT INTO `gm_configuration` SET `gm_key` = "LOG_IP_ACCOUNT_CONTACT", `gm_value` = "0"';
	$t_success &= $this->query($query, true);
}

// Add new gm_conf "LOG_IP_ACCOUNT_ADDRESS_BOOK"
$check = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key` = "LOG_IP_ACCOUNT_ADDRESS_BOOK"', true);
if($check->num_rows === 0)
{
	$query     = 'INSERT INTO `gm_configuration` SET `gm_key` = "LOG_IP_ACCOUNT_ADDRESS_BOOK", `gm_value` = "0"';
	$t_success &= $this->query($query, true);
}

// Add new gm_conf "LOG_IP_ACCOUNT_NEWSLETTER"
$check = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key` = "LOG_IP_ACCOUNT_NEWSLETTER"', true);
if($check->num_rows === 0)
{
	$query     = 'INSERT INTO `gm_configuration` SET `gm_key` = "LOG_IP_ACCOUNT_NEWSLETTER", `gm_value` = "0"';
	$t_success &= $this->query($query, true);
}

// Add new gm_conf "LOG_IP_WITHDRAWAL_WEB_FORM"
$check = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key` = "LOG_IP_WITHDRAWAL_WEB_FORM"', true);
if($check->num_rows === 0)
{
	$query     = 'INSERT INTO `gm_configuration` SET `gm_key` = "LOG_IP_WITHDRAWAL_WEB_FORM", `gm_value` = "0"';
	$t_success &= $this->query($query, true);
}

// Add new gm_conf "LOG_IP_GV_SEND"
$check = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key` = "LOG_IP_GV_SEND"', true);
if($check->num_rows === 0)
{
	$query     = 'INSERT INTO `gm_configuration` SET `gm_key` = "LOG_IP_GV_SEND", `gm_value` = "0"';
	$t_success &= $this->query($query, true);
}

// Add new gm_conf "LOG_IP_SHIPPING"
$check = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key` = "LOG_IP_SHIPPING"', true);
if($check->num_rows === 0)
{
	$query     = 'INSERT INTO `gm_configuration` SET `gm_key` = "LOG_IP_SHIPPING", `gm_value` = "0"';
	$t_success &= $this->query($query, true);
}

// Add new gm_conf "LOG_IP_ORDER_SHIPPING_ADDRESS"
$check = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key` = "LOG_IP_ORDER_SHIPPING_ADDRESS"', true);
if($check->num_rows === 0)
{
	$query     = 'INSERT INTO `gm_configuration` SET `gm_key` = "LOG_IP_ORDER_SHIPPING_ADDRESS", `gm_value` = "0"';
	$t_success &= $this->query($query, true);
}

// Add new gm_conf "LOG_IP_ORDER_PAYMENT_ADDRESS"
$check = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key` = "LOG_IP_ORDER_PAYMENT_ADDRESS"', true);
if($check->num_rows === 0)
{
	$query     = 'INSERT INTO `gm_configuration` SET `gm_key` = "LOG_IP_ORDER_PAYMENT_ADDRESS", `gm_value` = "0"';
	$t_success &= $this->query($query, true);
}

// Adds configuration key or optional account names.
$check = $this->query('SELECT * FROM `configuration` WHERE `configuration_key` = "GENDER_MANDATORY"', true);
if($check->num_rows === 0)
{
	$query = 'INSERT INTO `configuration` SET `configuration_key` = "GENDER_MANDATORY", `configuration_value` = "false", `configuration_group_id` = 5, `sort_order` = 9, `use_function` = NULL, `set_function` = "gm_cfg_select_option(array(\'true\', \'false\'),", `date_added` = NOW();';
	$t_success &= $this->query($query, true);
}

// Move admin acces group item "parcel_services.php" into the right admin acces group
$groupId1 = $this->getAdminAccessGroupIdByIdentifier('PAGE', 'parcel_services.php');
$groupId2 = $this->getAdminAccessGroupIdByName('Paketdienste', 2);
if($groupId1 !== $groupId2 && $groupId1 > 0 && $groupId2 > 0)
{
	$query     = '
		UPDATE `admin_access_group_items`
		SET `admin_access_group_id` = ' . ((int)$groupId2) . '
		WHERE `identifier` = "parcel_services.php" AND `type` = "PAGE"
	';
	$t_success &= $this->query($query);
}

// Move admin acces group item "gm_id_starts.php" into the right admin acces group
$groupId1 = $this->getAdminAccessGroupIdByIdentifier('PAGE', 'gm_id_starts.php');
$groupId2 = $this->getAdminAccessGroupIdByName('Nummernkreise', 2);
if($groupId1 !== $groupId2 && $groupId1 > 0 && $groupId2 > 0)
{
	$query     = '
		UPDATE `admin_access_group_items`
		SET `admin_access_group_id` = ' . ((int)$groupId2) . '
		WHERE `identifier` = "gm_id_starts.php" AND `type` = "PAGE"
	';
	$t_success &= $this->query($query);
}