<?php
/* --------------------------------------------------------------
   dependent.inc.php 2018-09-06
   Gambio GmbH
   http://www.gambio.de
   Copyright © 2018 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------
*/

function insertGoogleConfigIfNotExist($db, $scope, $option, $default = '\"\"') {
	$query = 'SELECT * FROM `google_configurations` WHERE `scope` = "' . $scope . '" AND `option` = "' . $option . '"';
	
	$result = $db->query($query, true);
	
	if($result->num_rows === 0)
	{
		$query = 'INSERT INTO `google_configurations` (`scope`, `option`, `value`) VALUES ("' . $scope . '","' . $option
		         . '","{\"value\":' . $default . '}")';
		
		return $db->query($query) !== false;
	}
	
	return true;
}

if(!$this->table_exists('google_configurations'))
{
	$query     = 'CREATE TABLE `google_configurations` (
	`scope`         ENUM ("general", "adwords", "shopping", "analytics", "auth") NOT NULL,
	`option`        VARCHAR(255)                                         NOT NULL,
	`value`         VARCHAR(255)                                         NOT NULL,
	`last_modified` TIMESTAMP                                            NOT NULL DEFAULT CURRENT_TIMESTAMP
	ON UPDATE CURRENT_TIMESTAMP,
	PRIMARY KEY (`scope`, `option`)
)
	ENGINE = InnoDB
	DEFAULT CHARSET = `utf8`';
	$t_success &= $this->query($query);
}

insertGoogleConfigIfNotExist($this, 'general', 'connection-status', 'false');
insertGoogleConfigIfNotExist($this, 'auth', 'refresh-token');
insertGoogleConfigIfNotExist($this, 'auth', 'access-token');
insertGoogleConfigIfNotExist($this, 'auth', 'expiration-timestamp');
insertGoogleConfigIfNotExist($this, 'analytics', 'ua-tracking-code');
insertGoogleConfigIfNotExist($this, 'analytics', 'enabled', 'false');
insertGoogleConfigIfNotExist($this, 'analytics', 'anonymize-ip', 'true');
insertGoogleConfigIfNotExist($this, 'analytics', 'price-net', 'true');
insertGoogleConfigIfNotExist($this, 'analytics', 'box-impression-tracking', 'true');
insertGoogleConfigIfNotExist($this, 'analytics', 'listing-impression-tracking', 'true');
insertGoogleConfigIfNotExist($this, 'analytics', 'product-click-tracking', 'true');
insertGoogleConfigIfNotExist($this, 'analytics', 'product-details-tracking', 'true');
insertGoogleConfigIfNotExist($this, 'analytics', 'shopping-cart-tracking', 'true');
insertGoogleConfigIfNotExist($this, 'analytics', 'checkout-tracking', 'true');
insertGoogleConfigIfNotExist($this, 'analytics', 'dev-mode', 'false');
insertGoogleConfigIfNotExist($this, 'analytics', 'box-bestseller-name', '\"Bestseller Box\"');
insertGoogleConfigIfNotExist($this, 'analytics', 'box-specials-name', '\"Specials Box\"');
insertGoogleConfigIfNotExist($this, 'analytics', 'box-whats-new-name', '\"Whats New Box\"');
insertGoogleConfigIfNotExist($this, 'analytics', 'list-bestseller-name', '\"Bestseller List\"');
insertGoogleConfigIfNotExist($this, 'analytics', 'list-specials-name', '\"Specials List\"');
insertGoogleConfigIfNotExist($this, 'analytics', 'list-whats-new-name', '\"Whats New List\"');
insertGoogleConfigIfNotExist($this, 'analytics', 'list-available-soon-name', '\"Available Soon List\"');
insertGoogleConfigIfNotExist($this, 'analytics', 'list-top-products-name', '\"Top Products List\"');
insertGoogleConfigIfNotExist($this, 'analytics', 'gtag-js-file-name');
insertGoogleConfigIfNotExist($this, 'analytics', 'analytics-js-file-name');
insertGoogleConfigIfNotExist($this, 'analytics', 'ec-plugin-js-file-name');

$check = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key` = "GOOGLE_ADWORDS_CONNECTION_STATUS"', true);

if($check->num_rows === 1)
{
	$connectionStatus = $this->query('SELECT `gm_value` FROM `gm_configuration` WHERE `gm_key` = "GOOGLE_ADWORDS_CONNECTION_STATUS"');
	
	$connected = array_key_exists(0, $connectionStatus)
	             && $connectionStatus[0]['gm_value'] === 'true' ? 'true' : 'false';
	
	$query     = 'DELETE FROM `gm_configuration` WHERE `gm_key` = "GOOGLE_ADWORDS_CONNECTION_STATUS"';
	$t_success &= $this->query($query, true);
	
	$check = $this->query('SELECT * FROM `google_configurations` WHERE `scope` = "general" AND `option` = "connection-status"',
	                      true);
	
	if($check->num_rows === 0)
	{
		$query     = 'REPLACE INTO `google_configurations` (`scope`, `option`, `value`) VALUES
			("general", "connection-status", "{\"value\": ' . $connected . '}")';
		$t_success &= $this->query($query, true);
	}
}

$check = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key` = "GOOGLE_ADWORDS_REFRESH_TOKEN"', true);
if($check->num_rows === 1)
{
	$refreshTokenResult = $this->query('SELECT `gm_value` FROM `gm_configuration` WHERE `gm_key` = "GOOGLE_ADWORDS_REFRESH_TOKEN"');
	$refreshToken       = array_key_exists(0, $refreshTokenResult) ? $refreshTokenResult[0]['gm_value'] : '';
	
	$query     = 'DELETE FROM `gm_configuration` WHERE `gm_key` = "GOOGLE_ADWORDS_REFRESH_TOKEN"';
	$t_success &= $this->query($query, true);
	
	$check = $this->query('SELECT * FROM `google_configurations` WHERE `scope` = "auth" AND `option` = "refresh-token"',
	                      true);
	
	if($check->num_rows === 0)
	{
		$query     = 'REPLACE INTO `google_configurations` (`scope`, `option`, `value`) VALUES
			("auth", "refresh-token", "{\"value\": \"' . $refreshToken . '\"}")';
		$t_success &= $this->query($query, true);
	}
}

if(!$this->table_exists('google_adwords_client_customers'))
{
	$query     = 'CREATE TABLE `google_adwords_client_customers` (
  `client_customer_id` varchar(12) NOT NULL,
  `primary` int(1) NOT NULL DEFAULT "0",
  PRIMARY KEY (`client_customer_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8';
	$t_success &= $this->query($query);
}
