<?php
/* --------------------------------------------------------------
   dependent.inc.php 2018-04-13
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2018 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------
*/

/** @var \DatabaseModel $this */

# Change format for value attribute in configuration_storage table
if($this->table_exists('configuration_storage'))
{
	$t_query   = 'ALTER TABLE `configuration_storage` MODIFY `value` text DEFAULT NULL;';
	$t_success &= $this->query($t_query, true);
}

# Unprotect imported admin access roles
/** @var \mysqli_result $admins */
$admins = $this->query('
	SELECT `customers_firstname` AS `firstname`, `customers_lastname` AS `lastname`
	FROM `customers`
	WHERE customers_status = 0 AND customers_id != 1;
', true);
if($admins->num_rows > 0)
{
	while($admin = $admins->fetch_assoc())
	{
		$roleNameEn = 'Admin role for ' . $admin['firstname'] . ' ' . $admin['lastname'];
		$roleNameDe = 'Admin Rolle für ' . $admin['firstname'] . ' ' . $admin['lastname'];
		
		/** @var \mysqli_result $role */
		$role = $this->query('
			SELECT `descriptions`.`admin_access_role_id`
			FROM `admin_access_role_descriptions` AS `descriptions`
			JOIN `admin_access_roles` AS `roles`
				ON `descriptions`.`admin_access_role_id` = `roles`.`admin_access_role_id`
			WHERE
				`roles`.`protected` = 1
				AND (
					`descriptions`.`name` = "' . $this->real_escape_string($roleNameEn) . '"
					OR `descriptions`.`name` = "' . $this->real_escape_string($roleNameDe) . '"
				)
			GROUP BY `descriptions`.`admin_access_role_id`;
		', true);
		if($role->num_rows === 1)
		{
			$role = $role->fetch_assoc();
			
			$t_success &= $this->query('
				UPDATE `admin_access_roles`
				SET `protected` = 0
				WHERE `admin_access_role_id` = ' . $role['admin_access_role_id'] . ';
			', true);
		}
	}
}

// Add new gm_conf "PRODUCT_REVIEW_NAME"
$check = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key` = "PRODUCT_REVIEW_NAME"', true);
if($check->num_rows === 0)
{
	$query     = 'INSERT INTO `gm_configuration` SET `gm_key` = "PRODUCT_REVIEW_NAME", `gm_value` = "short_nothing"';
	$t_success &= $this->query($query, true);
}

// Update configuration_key for b2czones shipping module
$newStaticKeyNames  = array(
	# old name => new name
	'MODULE_SHIPPING_B2C_ZONES_ALIAS'      => 'MODULE_SHIPPING_B2CZONES_ALIAS',
	'MODULE_SHIPPING_B2C_ZONES_STATUS'     => 'MODULE_SHIPPING_B2CZONES_STATUS',
	'MODULE_SHIPPING_B2C_ZONES_ALLOWED'    => 'MODULE_SHIPPING_B2CZONES_ALLOWED',
	'MODULE_SHIPPING_B2C_ZONES_TAX_CLASS'  => 'MODULE_SHIPPING_B2CZONES_TAX_CLASS',
	'MODULE_SHIPPING_B2C_ZONES_SORT_ORDER' => 'MODULE_SHIPPING_B2CZONES_SORT_ORDER',
);
$numZones           = 10;
$newDynamicKeyNames = array(
	# old name => new name
	'MODULE_SHIPPING_B2C_ZONES_COUNTRIES_' => 'MODULE_SHIPPING_B2CZONES_COUNTRIES_',
	'MODULE_SHIPPING_B2C_ZONES_COST_'      => 'MODULE_SHIPPING_B2CZONES_COST_',
	'MODULE_SHIPPING_B2C_ZONES_HANDLING_'  => 'MODULE_SHIPPING_B2CZONES_HANDLING_',
);
foreach($newStaticKeyNames AS $oldName => $newName)
{
	$check  = $this->query('SELECT * FROM `configuration` WHERE `configuration_key` = "' . $oldName . '"', true);
	$check2 = $this->query('SELECT * FROM `configuration` WHERE `configuration_key` = "' . $newName . '"', true);
	if($check->num_rows === 1 && $check2->num_rows === 0)
	{
		$query     = 'UPDATE `configuration` SET `configuration_key` = "' . $newName . '" WHERE `configuration_key` = "'
		             . $oldName . '"';
		$t_success &= $this->query($query, true);
	}
}
for($i = 1; $i <= $numZones; $i++)
{
	foreach($newDynamicKeyNames AS $oldName => $newName)
	{
		$check  = $this->query('SELECT * FROM `configuration` WHERE `configuration_key` = "' . $oldName . $i . '"',
		                       true);
		$check2 = $this->query('SELECT * FROM `configuration` WHERE `configuration_key` = "' . $newName . $i . '"',
		                       true);
		if($check->num_rows === 1 && $check2->num_rows === 0)
		{
			$query     = 'UPDATE `configuration` SET `configuration_key` = "' . $newName . $i
			             . '" WHERE `configuration_key` = "' . $oldName . $i . '"';
			$t_success &= $this->query($query, true);
		}
	}
}

// Remove old and unused content manager entries
$check  = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key` = "GM_WITHDRAWAL_CONTENT_ID" AND `gm_value` = 9',
                       true);
$check2 = $this->query('SELECT * FROM `content_manager` WHERE `content_group` = 9 AND `content_status` = 0', true);
$check3 = $this->query('SELECT * FROM `content_manager` WHERE `content_group` = 9', true);
if($check->num_rows === 0 && $check2->num_rows > 0 && $check2->num_rows === $check3->num_rows)
{
	$query     = 'DELETE FROM `content_manager` WHERE `content_group` = 9';
	$t_success &= $this->query($query, true);
}

$check  = $this->query('SELECT * FROM `configuration` WHERE `configuration_key` = "SHIPPING_INFOS" AND `configuration_value` = 1',
                       true);
$check2 = $this->query('SELECT * FROM `content_manager` WHERE `content_group` = 1 AND `content_status` = 0', true);
$check3 = $this->query('SELECT * FROM `content_manager` WHERE `content_group` = 1', true);
if($check->num_rows === 0 && $check2->num_rows > 0 && $check2->num_rows === $check3->num_rows)
{
	$query     = 'DELETE FROM `content_manager` WHERE `content_group` = 1';
	$t_success &= $this->query($query, true);
}